<?php
require_once "WCBuilderProBase.php";

class WCBuilderPro {
    public $plugin_file=WPBFORWPBAKERY_PRO_ADDONS_PL_ROOT;
    public $responseObj;
    public $licenseMessage;
    public $showMessage=false;
    public $slug="wpbforwpbakerypro_license";
    function __construct() {
	    add_action( 'admin_print_styles', [ $this, 'SetAdminStyle' ] );
	    $licenseKey=get_option("WCBuilderPro_lic_Key","");
	    $liceEmail=get_option( "WCBuilderPro_lic_email","");
        WCBuilderProBase::addOnDelete(function(){
           delete_option("WCBuilderPro_lic_Key");
        });
	    if(WCBuilderProBase::CheckWPPlugin($licenseKey,$liceEmail,$this->licenseMessage,$this->responseObj,__FILE__)){
		    add_action( 'admin_menu', [$this,'ActiveAdminMenu'], 30);
		    add_action( 'admin_post_WCBuilderPro_el_deactivate_license', [ $this, 'action_deactivate_license' ] );
		    //$this->licenselMessage=$this->mess;
		    //Write you plugin's code here

	    }else{
	        if(!empty($licenseKey) && !empty($this->licenseMessage)){
	           $this->showMessage=true;
            }
		    update_option("WCBuilderPro_lic_Key","") || add_option("WCBuilderPro_lic_Key","");
		    add_action( 'admin_post_WCBuilderPro_el_activate_license', [ $this, 'action_activate_license' ] );
		    add_action( 'admin_menu', [$this,'InactiveMenu'], 30);

		    add_action( 'admin_head', array( $this, 'dismiss' ) );
		    add_action( 'switch_theme', array( $this, 'update_dismiss' ) );
		    add_action( 'admin_notices', [ $this, 'license_notice'] );
	    }
    }
	function SetAdminStyle() {
		wp_register_style( "WCBuilderProLic", plugins_url("style.css",$this->plugin_file),10);
		wp_enqueue_style( "WCBuilderProLic" );
	}
    function ActiveAdminMenu(){
	    add_submenu_page (  "edit.php?post_type=wpbfwpb_template", "License", "License", 'activate_plugins', $this->slug, [$this,"Activated"]);

    }
    function InactiveMenu() {
	    add_submenu_page( "edit.php?post_type=wpbfwpb_template", "License", "License", 'activate_plugins', $this->slug,  [$this,"LicenseForm"]);

    }
    function action_activate_license(){
    		check_admin_referer( 'el-license' );
    		$licenseKey=!empty($_POST['el_license_key'])?$_POST['el_license_key']:"";
    		$licenseEmail=!empty($_POST['el_license_email'])?$_POST['el_license_email']:"";
    		update_option("WCBuilderPro_lic_Key",$licenseKey) || add_option("WCBuilderPro_lic_Key",$licenseKey);
    		update_option("WCBuilderPro_lic_email",$licenseEmail) || add_option("WCBuilderPro_lic_email",$licenseEmail);
    		wp_safe_redirect(admin_url( 'admin.php?page='.$this->slug));
    	}
    function action_deactivate_license() {
	    check_admin_referer( 'el-license' );
	    if(WCBuilderProBase::RemoveLicenseKey(__FILE__,$message)){
		    update_option("WCBuilderPro_lic_Key","") || add_option("WCBuilderPro_lic_Key","");
	    }
	    wp_safe_redirect(admin_url( 'admin.php?page='.$this->slug));
    }
    function Activated(){
        ?>
        <form method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
            <input type="hidden" name="action" value="WCBuilderPro_el_deactivate_license"/>
            <div class="el-license-container">
                <h3 class="el-license-title"><i class="dashicons-before dashicons-star-filled"></i> <?php _e("WC Builder Pro License Info",$this->slug);?> </h3>
                <hr>
                <ul class="el-license-info">
                <li>
                    <div>
                        <span class="el-license-info-title"><?php _e("Status",$this->slug);?></span>

			            <?php if ( $this->responseObj->is_valid ) : ?>
                            <span class="el-license-valid"><?php _e("Valid",$this->slug);?></span>
			            <?php else : ?>
                            <span class="el-license-valid"><?php _e("Invalid",$this->slug);?></span>
			            <?php endif; ?>
                    </div>
                </li>

                <li>
                    <div>
                        <span class="el-license-info-title"><?php _e("License Type",$this->slug);?></span>
			            <?php echo $this->responseObj->license_title; ?>
                    </div>
                </li>

                <li>
                    <div>
                        <span class="el-license-info-title"><?php _e("License Expired on",$this->slug);?></span>
			            <?php echo $this->responseObj->expire_date; ?>
                    </div>
                </li>

                <li>
                    <div>
                        <span class="el-license-info-title"><?php _e("Support Expired on",$this->slug);?></span>
			            <?php echo $this->responseObj->support_end; ?>
                    </div>
                </li>
                    <li>
                        <div>
                            <span class="el-license-info-title"><?php _e("Your License Key",$this->slug);?></span>
                            <span class="el-license-key"><?php echo esc_attr( substr($this->responseObj->license_key,0,9)."XXXXXXXX-XXXXXXXX".substr($this->responseObj->license_key,-9) ); ?></span>
                        </div>
                    </li>
                </ul>
                <div class="el-license-active-btn">
				    <?php wp_nonce_field( 'el-license' ); ?>
				    <?php submit_button('Deactivate'); ?>
                </div>
            </div>
        </form>
	<?php
    }

    function LicenseForm() {
	    ?>
    <form method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
	    <input type="hidden" name="action" value="WCBuilderPro_el_activate_license"/>
	    <div class="el-license-container">
		    <h3 class="el-license-title"><i class="dashicons-before dashicons-star-filled"></i> <?php _e("WC Builder Pro Licensing",$this->slug);?></h3>
		    <hr>
            <?php
            if(!empty($this->showMessage) && !empty($this->licenseMessage)){
                ?>
                <div class="notice notice-error is-dismissible">
                    <p><?php echo _e($this->licenseMessage,$this->slug); ?></p>
                </div>
                <?php
            }
            ?>
		    <p><?php _e("Enter your license key here, to activate the product, and get full feature updates and premium support.",$this->slug);?></p>
		    <ol>
			    <li><?php _e("Write your licnese key details",$this->slug);?></li>
			    <li><?php _e("How buyer will get this license key?",$this->slug);?></li>
			    <li><?php _e("Describe other info about licensing if required",$this->slug);?></li>
                <li>. ...</li>
		    </ol>
		    <div class="el-license-field">
			    <label for="el_license_key"><?php _e("License code",$this->slug);?></label>
			    <input type="text" class="regular-text code" name="el_license_key" size="50" placeholder="xxxxxxxx-xxxxxxxx-xxxxxxxx-xxxxxxxx" required="required">
		    </div>
            <div class="el-license-field">
                <label for="el_license_key"><?php _e("Email Address",$this->slug);?></label>
                <?php
                    $purchaseEmail   = get_option( "WCBuilderPro_lic_email", get_bloginfo( 'admin_email' ));
                ?>
                <input type="text" class="regular-text code" name="el_license_email" size="50" value="<?php echo $purchaseEmail; ?>" placeholder="" required="required">
                <div><small><?php _e("We will send update news of this product by this email address, don't worry, we hate spam",$this->slug);?></small></div>
            </div>
		    <div class="el-license-active-btn">
			    <?php wp_nonce_field( 'el-license' ); ?>
			    <?php submit_button('Activate'); ?>
		    </div>
	    </div>
    </form>
	    <?php
    }


    public function dismiss() {
    	if ( isset( $_GET['wpbforwpbakerypro-dismiss'] ) && check_admin_referer( 'wpbforwpbakerypro-dismiss-' . get_current_user_id() ) ) {
    		update_user_meta( get_current_user_id(), 'wpbforwpbakerypro_dismissed_notice_id', 1 );
    	}
    }

    public function update_dismiss() {
    	delete_metadata( 'user', null, 'wpbforwpbakerypro_dismissed_notice_id', null, true );
    }

    function license_notice() {
    	if( get_user_meta( get_current_user_id(), 'wpbforwpbakerypro_dismissed_notice_id', true ) ){
    		return;
    	}

    	$button = sprintf('<a href="%1s" class="button button-primary">%2s</a>',
    		admin_url( 'admin.php?page='.$this->slug),
    		__('Activate License', 'wpbforwpbakerypro')
    	);
        ?>
        <div class="notice wpbforwpbakerypro-notice notice-warning">
        	<strong><?php echo esc_html__('Welcome to WC Builder Pro!', 'wpbforwpbakerypro'); ?></strong>
    		<p><?php echo esc_html__( 'Please activate your license/purchase code to get automatic theme updates.', 'wpbforwpbakerypro' ); ?></p>
    		<div><?php echo wp_kses_post( $button ); ?></div>
    		<a href="<?php echo esc_url( wp_nonce_url( add_query_arg( 'wpbforwpbakerypro-dismiss', 'dismiss_admin_notices' ), 'wpbforwpbakerypro-dismiss-' . get_current_user_id() ) ); ?>">
    			<button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button>
    		</a>
        </div>
        <?php
    }
}

new WCBuilderPro();