<?php
class WPBForWPbakeryPro_Cart_Total{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_cart_total', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
    	if( !is_cart() ){ 
    		return;
    	}
    	
        extract(shortcode_atts(array(
            'title_text_align' => '', 
            'table_title_color' => '', 
            'table_title_font_size' => '',
            'use_title_google_font' => '', 
            'title_google_font' => 'font_family:Abril Fatface|font_style:400 regular',
            'heading_text_align' => '', 
            'heading_text_color' => '', 
            'heading_font_size' => '',
            'use_heading_google_font' => '', 
            'heading_google_font' => 'font_family:Abril Fatface|font_style:400 regular',
            'table_cell_border_color'=>'',
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');

         $title_fonts_style = '';
        if( $use_title_google_font == 'true'){
            $title_font_data = wpbforwpbakerypro_get_fonts_data( $title_google_font );
            wpbforwpbakerypro_enqueue_google_font( $title_font_data );
            $title_fonts_style = wpbforwpbakerypro_get_font_inline_style( $title_font_data );
        }

         $heading_fonts_style = '';
        if( $use_heading_google_font == 'true'){
            $heading_font_data = wpbforwpbakerypro_get_fonts_data( $heading_google_font );
            wpbforwpbakerypro_enqueue_google_font( $heading_font_data );
            $heading_fonts_style = wpbforwpbakerypro_get_font_inline_style( $heading_font_data );
        }

        $style = '<style>';

        if( $title_text_align != "" ){
            $style .=  ".$unique_class .cart_totals h2{ text-align:{$title_text_align} !important; }";
        }

        if( $table_title_color != "" ){
            $style .=  ".$unique_class .cart_totals h2{ color:{$table_title_color} !important; }";
        }

        if( $table_title_font_size != "" ){
            $style .=  ".$unique_class .cart_totals h2{ font-size:{$table_title_font_size} !important; }";
        }

        if( $title_fonts_style != "" ){
            $style .=  ".$unique_class .cart_totals h2{ {$title_fonts_style} }";
        }

        if( $heading_text_align != "" ){
            $style .=  ".$unique_class .cart_totals .shop_table th{ text-align:{$heading_text_align} !important; }";
        }

        if( $heading_text_color != "" ){
            $style .=  ".$unique_class .cart_totals .shop_table th{ color:{$heading_text_color} !important; }";
        }

        if( $heading_font_size != "" ){
            $style .=  ".$unique_class .cart_totals .shop_table th{ font-size:{$heading_font_size} !important; }";
        }

        if( $heading_fonts_style != "" ){
            $style .=  ".$unique_class .cart_totals .shop_table th{ {$heading_fonts_style} }";
        }

        if( $table_cell_border_color != "" ){
            $style .=  ".$unique_class .cart_totals .shop_table tr td,.$unique_class .cart_totals .shop_table,.$unique_class .cart_totals .shop_table tr th{ border-color:{$table_cell_border_color} !important; }";
        }
        $style .= '</style>';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

        woocommerce_cart_totals();

    	echo '</div>';
        return $style.= ob_get_clean();
    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: Cart Total", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_cart_total",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_cart_total_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
                array(
                  "param_name" => "title_text_align",
                  "heading" => __("Title Text Align", 'wpbforwpbakery'),
                  "type" => "dropdown",
                  "default_set" => 'left',
                  'value' => wpbforwpbakerypro_text_align_lists(),
                ),
                array(
                    'param_name' => 'table_title_color',
                    'heading' => __( 'Title color', 'wpbforwpbakery' ),
                    'type' => 'colorpicker',
                ),
                array(
                    'param_name' => 'table_title_font_size',
                    'heading' => __( 'Title Font size', 'wpbforwpbakery' ),
                    'type' => 'textfield',
                    'description' => __( 'Ex: 23px', 'wpbforwpbakery' ),
                ),
                array(
                  'type' => 'checkbox',
                  'heading' => __( 'Use Title google font?', 'wpbforwpbakery' ),
                  'param_name' => 'use_title_google_font',
                  'description' => __( 'Use font family from google font.', 'wpbforwpbakery' ),
                ),
                array(
                  'type' => 'google_fonts',
                  'param_name' => 'title_google_font',
                  'settings' => array(
                    'fields' => array(
                      'font_family_description' => __( 'Select font family.', 'wpbforwpbakery' ),
                      'font_style_description' => __( 'Select font styling.', 'wpbforwpbakery' ),
                    ),
                  ),
                  'dependency' =>[
                      'element' => 'use_title_google_font',
                      'value' => array( 'true' ),
                  ],
                ),
                array(
                  "param_name" => "heading_text_align",
                  "heading" => __("Heading Text Align", 'wpbforwpbakery'),
                  "type" => "dropdown",
                  "default_set" => 'left',
                  'value' => wpbforwpbakerypro_text_align_lists(),
                ),
                array(
                    'param_name' => 'heading_text_color',
                    'heading' => __( 'Heading Text color', 'wpbforwpbakery' ),
                    'type' => 'colorpicker',
                ),
                array(
                    'param_name' => 'heading_font_size',
                    'heading' => __( 'Heading Font Size', 'wpbforwpbakery' ),
                    'type' => 'textfield',
                    'description' => __( 'Ex: 23px', 'wpbforwpbakery' ),
                ),
                array(
                  'type' => 'checkbox',
                  'heading' => __( 'Use Heading google font?', 'wpbforwpbakery' ),
                  'param_name' => 'use_heading_google_font',
                  'description' => __( 'Use font family from google font.', 'wpbforwpbakery' ),
                ),
                array(
                  'type' => 'google_fonts',
                  'param_name' => 'heading_google_font',
                  'settings' => array(
                    'fields' => array(
                      'font_family_description' => __( 'Select font family.', 'wpbforwpbakery' ),
                      'font_style_description' => __( 'Select font styling.', 'wpbforwpbakery' ),
                    ),
                  ),
                  'dependency' =>[
                      'element' => 'use_heading_google_font',
                      'value' => array( 'true' ),
                  ],
                ),
                array(
                    'param_name' => 'table_cell_border_color',
                    'heading' => __( 'Table Cell border color', 'wpbforwpbakery' ),
                    'type' => 'colorpicker',
                ),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}

new WPBForWPbakeryPro_Cart_Total();