<?php
class WPBForWPbakeryPro_Checkout_Billing{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_checkout_billing', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'form_heading_color' => '', 
            'form_heading_size' => '', 
            'form_heading_line_height' => '', 
            'form_heading_align' => '', 
            'form_label_color' => '', 
            'form_label_font_size' => '', 
            'form_label_line_height' => '', 
            'form_label_align' => '', 
            'form_input_box_text_color' => '', 
            'form_input_box_font_size' => '', 
            'form_input_box_line_height' => '', 
            'form_input_box_border' => '', 
            'form_input_box_border_radius' => '', 
            'form_input_box_padding' => '', 
            'form_input_box_margin' => '', 
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));


        if( is_checkout() ){

        	ob_start();
        	$unique_class = uniqid('wpbforwpbakerypro_checkout_additional_');
        	$output = '<style>';
            $output .= ".$unique_class .woocommerce-billing-fields .form-row{display:block; }";
        	$output .= ".$unique_class .woocommerce-billing-fields > h3{color:{$form_heading_color};font-size:{$form_heading_size};line-height:{$form_heading_line_height}; text-align:{$form_heading_align}; }";
        	$output .= ".$unique_class .woocommerce-billing-fields .form-row label{color:{$form_label_color};font-size:{$form_label_font_size};line-height:{$form_label_line_height}; text-align:{$form_label_align}; }";
        	$output .= ".$unique_class .woocommerce-billing-fields input.input-text{color:{$form_input_box_text_color};font-size:{$form_input_box_font_size};line-height:{$form_input_box_line_height}; border: {$form_input_box_border}; border-radius:{$form_input_box_border_radius}; padding:{$form_input_box_padding}; margin:{$form_input_box_margin}; }";
        	$output .= '</style>';

        	echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

            $checkout = wc()->checkout();
            if( sizeof( $checkout->checkout_fields ) > 0 ){
                do_action( 'woocommerce_checkout_billing' );
            }

            echo '</div>';

            return $output.= ob_get_clean();
        }
    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: Checkout Billing", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_checkout_billing",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_checkout_billing_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'form_heading_color',
            	    'heading' => esc_html__( 'Heading Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_heading_size',
            	    'heading' => esc_html__( 'Heading Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_heading_line_height',
            	    'heading' => esc_html__( 'Heading Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	  "param_name" => "form_heading_align",
            	  "heading" => esc_html__("Heading Text Align", 'wpbforwpbakerypro'),
            	  "type" => "dropdown",
            	  "default_set" => 'left',
            	  'value' => wpbforwpbakerypro_text_align_lists(),
            	),
            	array(
            	    'param_name' => 'form_label_color',
            	    'heading' => esc_html__( 'Label Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_label_font_size',
            	    'heading' => esc_html__( 'Label Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_label_line_height',
            	    'heading' => esc_html__( 'Label Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	  "param_name" => "form_label_align",
            	  "heading" => esc_html__("Label Text Align", 'wpbforwpbakerypro'),
            	  "type" => "dropdown",
            	  "default_set" => 'left',
            	  'value' => wpbforwpbakerypro_text_align_lists(),
            	),
            	array(
            	    'param_name' => 'form_input_box_text_color',
            	    'heading' => esc_html__( 'Input Box Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_input_box_font_size',
            	    'heading' => esc_html__( 'Input Box Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_line_height',
            	    'heading' => esc_html__( 'Input Box Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_border',
            	    'heading' => esc_html__( 'Input Box Border', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 1px solid red', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_border_radius',
            	    'heading' => esc_html__( 'Input Box Border Radius', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS Border Radius. Example: 5px, which stand for border-radius:5px;', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_padding',
            	    'heading' => esc_html__( 'Input Box Padding', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_margin',
            	    'heading' => esc_html__( 'Input Box Magin', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS margin. Example: 18px 0, which stand for margin-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}

new WPBForWPbakeryPro_Checkout_Billing();