<?php
class WPBForWPbakeryPro_Checkout_Payment{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_checkout_payment', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'checkout_payment_bg_color' => '',
            'checkout_payment_heading_text_color' => '',
            'checkout_payment_heading_font_size' => '',
            'checkout_payment_heading_line_height' => '',
            'checkout_payment_heading_content_color' => '',
            'checkout_payment_heading_content_font_size' => '',
            'checkout_payment_heading_content_line_height' => '',
            'checkout_payment_content_color' => '',
            'checkout_payment_content_font_size' => '',
            'checkout_payment_content_line_height' => '',
            'checkout_payment_button_bg_color' => '',
            'checkout_payment_button_text_color' => '',
            'checkout_payment_button_font_size' => '',
            'checkout_payment_button_line_height' => '',
            'checkout_payment_button_hover_bg_color' => '',
            'checkout_payment_button_hover_text_color' => '',
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));

        if( is_checkout() ){
        	ob_start();
        	$unique_class = uniqid('wpbforwpbakerypro_checkout_payment_');
        	$output = '<style>';
        	$output .= ".woocommerce-checkout .$unique_class #payment{background-color:{$checkout_payment_bg_color}; }";
        	$output .= ".woocommerce-checkout .$unique_class #payment label{color:{$checkout_payment_heading_text_color}; font-size:{$checkout_payment_heading_font_size}; line-height:{$checkout_payment_heading_line_height}; }";
        	$output .= ".woocommerce-checkout .$unique_class  #payment div.payment_box{color:{$checkout_payment_heading_content_color}; font-size:{$checkout_payment_heading_content_font_size}; line-height:{$checkout_payment_heading_content_line_height}; }";
        	$output .= ".woocommerce-checkout .woocommerce-privacy-policy-text{color:{$checkout_payment_content_color}; font-size:{$checkout_payment_content_font_size}; line-height:{$checkout_payment_content_line_height}; }";
        	$output .= ".woocommerce-page .$unique_class #payment #place_order{background-color:{$checkout_payment_button_bg_color}; color:{$checkout_payment_button_text_color}; font-size:{$checkout_payment_button_font_size}; line-height:{$checkout_payment_button_line_height}; }";
        	$output .= ".woocommerce-page .$unique_class #payment #place_order:hover{background-color:{$checkout_payment_button_hover_bg_color}; color:{$checkout_payment_button_hover_text_color}; }";
        	$output .= '</style>';

        	echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

            if ( ! is_ajax() ){ do_action( 'woocommerce_review_order_before_payment' ); }
                woocommerce_checkout_payment();
            if ( ! is_ajax() ){ do_action( 'woocommerce_review_order_after_payment' ); }

            echo '</div>';
            return $output.= ob_get_clean();
        }

    }


    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: Checkout Payment", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_checkout_payment",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_checkout_payment_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'checkout_payment_bg_color',
            	    'heading' => esc_html__( 'Payment BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'checkout_payment_heading_text_color',
            	    'heading' => esc_html__( 'Heading Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'checkout_payment_heading_font_size',
            	    'heading' => esc_html__( 'Heading Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_heading_line_height',
            	    'heading' => esc_html__( 'Heading Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_heading_content_color',
            	    'heading' => esc_html__( 'Heading Content Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'checkout_payment_heading_content_font_size',
            	    'heading' => esc_html__( 'Heading Content Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_heading_content_line_height',
            	    'heading' => esc_html__( 'Heading Content Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_content_color',
            	    'heading' => esc_html__( 'Content Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'checkout_payment_content_font_size',
            	    'heading' => esc_html__( 'Content Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_content_line_height',
            	    'heading' => esc_html__( 'Content Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_button_bg_color',
            	    'heading' => esc_html__( 'Button BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_button_text_color',
            	    'heading' => esc_html__( 'Button  Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_button_font_size',
            	    'heading' => esc_html__( 'Button  Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_button_line_height',
            	    'heading' => esc_html__( 'Button  Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_button_hover_bg_color',
            	    'heading' => esc_html__( 'Button Hover BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'checkout_payment_button_hover_text_color',
            	    'heading' => esc_html__( 'Button Hover Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            )
        ) );
    }
}

new WPBForWPbakeryPro_Checkout_Payment();