<?php
class WPBForWPbakeryPro_Checkout_Shipping_Form{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_checkout_shipping_form', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'heading_custom_text' => 'Ship to a different address?', 
            'heading_text_color' => '', 
            'heading_font_size' => '', 
            'heading_line_height' => '', 
            'label_text_color' => '', 
            'label_font_size' => '', 
            'label_line_height' => '', 
            'input_box_text_color' => '', 
            'input_box_font_size' => '', 
            'input_box_line_height' => '', 
            'input_box_margin' => '', 
            'input_box_padding' => '', 
            'input_box_border' => '', 
            'input_box_border_radius' => '', 
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));

        if( is_checkout() ){
        	ob_start();

        	$unique_class = uniqid('wpbforwpbakerypro_shipping_form_');
        	$output = '<style>';
          $output .= ".woocommerce-checkout .$unique_class .woocommerce-shipping-fields .form-row{display:block;}";
        	$output .= ".woocommerce-checkout .$unique_class .woocommerce-shipping-fields h3{color:{$heading_text_color};font-size:{$heading_font_size}; line-height:{$heading_line_height}; }";
        	$output .= ".woocommerce-checkout .$unique_class .woocommerce-shipping-fields label{color:{$label_text_color};font-size:{$label_font_size}; line-height:{$label_line_height}; }";
        	$output .= ".woocommerce-checkout .$unique_class .woocommerce-shipping-fields .input-text{color:{$input_box_text_color};font-size:{$input_box_font_size}; line-height:{$input_box_line_height};margin:{$input_box_margin}; padding:{$input_box_padding}; border:{$input_box_border}; border-radius:{$input_box_border_radius}; }";
        	$output .= '</style>';

        	echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

        	if( is_checkout() ){
                $checkout = wc()->checkout();
                if( sizeof( $checkout->checkout_fields ) > 0 ){ ?>
                    <div class="woocommerce-shipping-fields">
                        <?php if ( true === WC()->cart->needs_shipping_address() ) : ?>
                    
                            <h3 id="ship-to-different-address">
                                <label class="woocommerce-form__label woocommerce-form__label-for-checkbox checkbox">
                                    <input id="ship-to-different-address-checkbox" class="woocommerce-form__input woocommerce-form__input-checkbox input-checkbox" <?php checked( apply_filters( 'woocommerce_ship_to_different_address_checked', 'shipping' === get_option( 'woocommerce_ship_to_destination' ) ? 1 : 0 ), 1 ); ?> type="checkbox" name="ship_to_different_address" value="1" /> <span><?php echo esc_html__( $heading_custom_text, 'wpbforwpbakerypro' ); ?></span>
                                </label>
                            </h3>
                    
                            <div class="shipping_address">
                                <?php do_action( 'woocommerce_before_checkout_shipping_form', $checkout ); ?>
                                <div class="woocommerce-shipping-fields__field-wrapper">
                                    <?php
                                        $fields = $checkout->get_checkout_fields( 'shipping' );
                                        foreach ( $fields as $key => $field ) {
                                            if ( isset( $field['country_field'], $fields[ $field['country_field'] ] ) ) {
                                                $field['country'] = $checkout->get_value( $field['country_field'] );
                                            }
                                            woocommerce_form_field( $key, $field, $checkout->get_value( $key ) );
                                        }
                                    ?>
                                </div>
                                <?php do_action( 'woocommerce_after_checkout_shipping_form', $checkout ); ?>
                            </div>
                    
                        <?php endif; ?>
                    </div>
                <?php
                }
            }

        	echo '</div>';
            return $output.= ob_get_clean();
   		}
   	}

   	public function integrateWithVC() {
   	    /*
   	    Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

   	    More info: http://kb.wpbakery.com/index.php?title=Vc_map
   	    */
   	    vc_map( array(
   	        "name" => esc_html__("WCB: Checkout Shipping Form", 'wpbforwpbakerypro'),
   	        "base" => "wpbforwpbakery_checkout_shipping_form",
   	        "class" => "",
   	        "controls" => "full",
   	        "icon" => 'wpbforwpbakerypro_checkout_shipping_form_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
   	        "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
   	        "params" => array(
              array(
                  'param_name' => 'heading_custom_text',
                  'heading' => esc_html__( 'Heading Custom Text', 'wpbforwpbakerypro' ),
                  'type' => 'textfield',
              ),
   	        	array(
   	        	    'param_name' => 'heading_text_color',
   	        	    'heading' => esc_html__( 'Heading Text Color', 'wpbforwpbakerypro' ),
   	        	    'type' => 'colorpicker',
   	        	),
   	        	array(
   	        	    'param_name' => 'heading_font_size',
   	        	    'heading' => esc_html__( 'Heading Font Size', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
   	        	),
   	        	array(
   	        	    'param_name' => 'heading_line_height',
   	        	    'heading' => esc_html__( 'Heading Line Height', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
   	        	),
   	        	array(
   	        	    'param_name' => 'label_text_color',
   	        	    'heading' => esc_html__( 'Label Text Color', 'wpbforwpbakerypro' ),
   	        	    'type' => 'colorpicker',
   	        	),
   	        	array(
   	        	    'param_name' => 'label_font_size',
   	        	    'heading' => esc_html__( 'Label Font Size', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
   	        	),
   	        	array(
   	        	    'param_name' => 'label_line_height',
   	        	    'heading' => esc_html__( 'Label Line Height', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
   	        	),
   	        	array(
   	        	    'param_name' => 'input_box_text_color',
   	        	    'heading' => esc_html__( 'Input Box Text Color', 'wpbforwpbakerypro' ),
   	        	    'type' => 'colorpicker',
   	        	),
   	        	array(
   	        	    'param_name' => 'input_box_font_size',
   	        	    'heading' => esc_html__( 'Input Box Font Size', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
   	        	),
   	        	array(
   	        	    'param_name' => 'input_box_line_height',
   	        	    'heading' => esc_html__( 'Input Box Line Height', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
   	        	),
   	        	array(
   	        	    'param_name' => 'input_box_margin',
   	        	    'heading' => esc_html__( 'Input box Margin', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'The CSS margin. Example: 18px 0, which stand for margin-top and margin-bottom is 18px', 'wpbforwpbakerypro' ),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
   	        	),
   	        	array(
   	        	    'param_name' => 'input_box_padding',
   	        	    'heading' => esc_html__( 'Input box Padding', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
   	        	),
   	        	array(
   	        	    'param_name' => 'input_box_border',
   	        	    'heading' => esc_html__( 'Input Box Border', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'The CSS Border. Example: 1px solid red', 'wpbforwpbakerypro' ),
   	        	),
   	        	array(
   	        	    'param_name' => 'input_box_border_radius',
   	        	    'heading' => esc_html__( 'Input Box Border Radius', 'wpbforwpbakerypro' ),
   	        	    'type' => 'textfield',
   	        	    'description' => esc_html__( 'The CSS Border Radius. Example: 5px, which stand for border-radius:5px;', 'wpbforwpbakerypro' ),
   	        	    'group'  => esc_html__( 'Styling', 'wpbforwpbakerypro' ),
   	        	),
   	            array(
   	                'param_name' => 'el_class',
   	                'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
   	                'type' => 'textfield',
   	                'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
   	            ),
   	            array(
   	              "param_name" => "wrapper_css",
   	              "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
   	              "type" => "css_editor",
   	              'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
   	          ),
   	        )
   	    ) );
   	}
}
new WPBForWPbakeryPro_Checkout_Shipping_Form();