<?php
class WPBForWPbakeryPro_Myaccount_Login_Form{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_myaccount_login_form', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
        	'form_label_color' => '', 
        	'form_label_font_size' => '', 
        	'form_label_line_height' => '', 
        	'form_label_align' => '', 
        	'form_input_box_text_color' => '', 
        	'form_input_box_font_size' => '', 
        	'form_input_box_line_height' => '', 
        	'form_input_box_border' => '', 
        	'form_input_box_border_radius' => '', 
        	'form_input_box_padding' => '', 
        	'form_input_box_margin' => '',
        	'form_button_bg_color' => '',
        	'form_button_text_color' => '',
        	'form_button_padding' => '', 
        	'form_button_margin' => '',
        	'form_button_hover_bg_color' => '',
        	'form_button_hover_text_color' => '',
            'el_class' => '', 
            'wrapper_css' => '', 
        ), $atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');
        $output = '<style>';

        $output .= ".woocommerce .$unique_class form .form-row label{color:{$form_label_color};font-size:{$form_label_font_size}; line-height:{$form_label_line_height}; text-align: {$form_label_align}; }";
        $output .= ".woocommerce .$unique_class form .form-row input.input-text{color:{$form_input_box_text_color};font-size:{$form_input_box_font_size}; line-height:{$form_input_box_line_height}; border: {$form_input_box_border}; border-radius:{$form_input_box_border_radius}; padding:{$form_input_box_padding}; margin: {$form_input_box_margin};  }";
        $output .= ".woocommerce .$unique_class button.button{color:{$form_button_text_color}; background-color:{$form_button_bg_color}; margin:{$form_button_margin}; padding:{$form_button_padding}; }";
        $output .= ".woocommerce .$unique_class button.button:hover{color:{$form_button_hover_text_color}; background-color:{$form_button_hover_bg_color}; }";

        $output .= '</style>';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

            if( !is_account_page() ){ do_action( 'woocommerce_before_customer_login_form' ); }

            ?>
            <div class="wpbforwpbakerypro-myaccount-form-login">

                <h2><?php esc_html_e( 'Login', 'wpbforwpbakerypro' ); ?></h2>
            
                <form class="woocommerce-form woocommerce-form-login login" method="post">
            
                    <?php do_action( 'woocommerce_login_form_start' ); ?>
            
                    <p class="woocommerce-form-row woocommerce-form-row--wide form-row form-row-wide">
                        <label for="username"><?php esc_html_e( 'Username or email address', 'wpbforwpbakerypro' ); ?>&nbsp;<span class="required">*</span></label>
                        <input type="text" class="woocommerce-Input woocommerce-Input--text input-text" name="username" id="username" autocomplete="username" value="<?php echo ( ! empty( $_POST['username'] ) ) ? esc_attr( wp_unslash( $_POST['username'] ) ) : ''; ?>" /><?php // @codingStandardsIgnoreLine ?>
                    </p>
                    <p class="woocommerce-form-row woocommerce-form-row--wide form-row form-row-wide">
                        <label for="password"><?php esc_html_e( 'Password', 'wpbforwpbakerypro' ); ?>&nbsp;<span class="required">*</span></label>
                        <input class="woocommerce-Input woocommerce-Input--text input-text" type="password" name="password" id="password" autocomplete="current-password" />
                    </p>
            
                    <?php do_action( 'woocommerce_login_form' ); ?>
            
                    <p class="form-row">
                        <?php wp_nonce_field( 'woocommerce-login', 'woocommerce-login-nonce' ); ?>
                        <button type="submit" class="woocommerce-Button button" name="login" value="<?php esc_attr_e( 'Log in', 'wpbforwpbakerypro' ); ?>"><?php esc_html_e( 'Log in', 'wpbforwpbakerypro' ); ?></button>
                        <label class="woocommerce-form__label woocommerce-form__label-for-checkbox inline">
                            <input class="woocommerce-form__input woocommerce-form__input-checkbox" name="rememberme" type="checkbox" id="rememberme" value="forever" /> <span><?php esc_html_e( 'Remember me', 'wpbforwpbakerypro' ); ?></span>
                        </label>
                    </p>

                    <p class="woocommerce-LostPassword lost_password">
                        <a href="<?php echo esc_url( wp_lostpassword_url() ); ?>"><?php esc_html_e( 'Lost your password?', 'wpbforwpbakerypro' ); ?></a>
                    </p>
            
                    <?php do_action( 'woocommerce_login_form_end' ); ?>
            
                </form>
            </div>
            <?php


		echo '</div>';
        return $output.= ob_get_clean();

    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: My Account Login Form", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_myaccount_login_form",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_myaccount_login_form_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'form_label_color',
            	    'heading' => esc_html__( 'Label Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_label_font_size',
            	    'heading' => esc_html__( 'Label Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'form_label_line_height',
            	    'heading' => esc_html__( 'Label Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
            	),
            	array(
            	  "param_name" => "form_label_align",
            	  "heading" => esc_html__("Label Text Align", 'wpbforwpbakerypro'),
            	  "type" => "dropdown",
            	  "default_set" => 'left',
            	  'value' => wpbforwpbakerypro_text_align_lists(),
            	),
            	array(
            	    'param_name' => 'form_input_box_text_color',
            	    'heading' => esc_html__( 'Input Box Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_input_box_font_size',
            	    'heading' => esc_html__( 'Input Box Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'form_input_box_line_height',
            	    'heading' => esc_html__( 'Input Box Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'form_input_box_border',
            	    'heading' => esc_html__( 'Input Box Border', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 1px solid red', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'form_input_box_border_radius',
            	    'heading' => esc_html__( 'Input Box Border Radius', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS Border Radius. Example: 5px, which stand for border-radius:5px;', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'form_input_box_padding',
            	    'heading' => esc_html__( 'Input Box Padding', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'form_input_box_margin',
            	    'heading' => esc_html__( 'Input Box Magin', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS margin. Example: 18px 0, which stand for margin-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'form_button_padding',
            	    'heading' => esc_html__( 'Input Box Padding', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
            	),

            	array(
            	    'param_name' => 'form_button_margin',
            	    'heading' => esc_html__( 'Input Box Magin', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS margin. Example: 18px 0, which stand for margin-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'form_button_bg_color',
            	    'heading' => esc_html__( 'Button BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_button_text_color',
            	    'heading' => esc_html__( 'Button Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_button_hover_bg_color',
            	    'heading' => esc_html__( 'Button Hover BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_button_hover_text_color',
            	    'heading' => esc_html__( 'Button Hover Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}
new WPBForWPbakeryPro_Myaccount_Login_Form();