<?php
class WPBForWPbakeryPro_Myaccount_Logout{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_myaccount_logout', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
        	'text_color' => '', 
        	'bg_color' => '', 
        	'text_font_size' => '', 
        	'text_line_height' => '', 
        	'text_align' => '',
        	'border' => '', 
        	'border_radius' => '', 
        	'padding' => '', 
        	'margin' => '',
        	'hover_bg_color' => '', 
        	'hover_text_color' => '',
            'el_class' => '', 
            'wrapper_css' => '', 
        ), $atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');
        $output = '<style>';

        $output .= ".woocommerce .$unique_class a{color:{$text_color};background-color:{$bg_color}; font-size:{$text_font_size}; line-height:{$text_line_height}; text-align: {$text_align}; border:{$border}; border-radius:{$border_radius}; padding:{$padding}; margin:{$margin};  }";
        $output .= ".woocommerce .$unique_class a:hover{color:{$hover_text_color};background-color:{$hover_bg_color};}";

        $output .= '</style>';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

        if ( ! is_user_logged_in() ) { return esc_html__('You need to logged in first', 'wpbforwpbakerypro'); }
        foreach ( wc_get_account_menu_items() as $endpoint => $label ) :
            if( $endpoint == 'customer-logout' ):
                ?>
                    <div class="wpbforwpbakerypro-customer-logout">
                        <a href="<?php echo esc_url( wc_logout_url( wc_get_page_permalink( 'myaccount' ) ) ); ?>"><?php echo esc_html( $label ); ?></a>
                    </div>
                <?php
            endif;
        endforeach;

		echo '</div>';
        return $output.= ob_get_clean();

    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: My Account Logout", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_myaccount_logout",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_myaccount_logout_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'text_color',
            	    'heading' => esc_html__( 'Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'bg_color',
            	    'heading' => esc_html__( 'Text BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'text_font_size',
            	    'heading' => esc_html__( 'Text Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'text_line_height',
            	    'heading' => esc_html__( 'Text Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	  "param_name" => "text_align",
            	  "heading" => esc_html__("Text Text Align", 'wpbforwpbakerypro'),
            	  "type" => "dropdown",
            	  "default_set" => 'left',
            	  'value' => wpbforwpbakerypro_text_align_lists(),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'border',
            	    'heading' => esc_html__( 'Border', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 1px solid red', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'border_radius',
            	    'heading' => esc_html__( 'Border Radius', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS Border Radius. Example: 5px, which stand for border-radius:5px;', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'padding',
            	    'heading' => esc_html__( 'Padding', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'margin',
            	    'heading' => esc_html__( 'Magin', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS margin. Example: 18px 0, which stand for margin-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
            	),
            	array(
            	    'param_name' => 'hover_bg_color',
            	    'heading' => esc_html__( 'Hover BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'hover_text_color',
            	    'heading' => esc_html__( 'Hover Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", "wpbforwpbakerypro" ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}
new WPBForWPbakeryPro_Myaccount_Logout();