<?php

if(!class_exists('WPBForWPbakery_Product_Meta')){


class WPBForWPbakery_Product_Meta{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_product_meta', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'text_align' => '', 
            'text_color' => '', 
            'font_size' => '', 
            'line_height' => '',
            'use_google_font' => '', 
            'google_font' => 'font_family:Abril Fatface|font_style:400 regular',
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));

        $unique_class = uniqid('wpbforwpbakery_meta_');

        global $product;
        $product = wc_get_product();

        $font_inline_style = '';
        if($use_google_font == 'true'){
            $font_data = wpbforwpbakerypro_get_fonts_data( $google_font );
            wpbforwpbakerypro_enqueue_google_font( $font_data );
            $font_inline_style = wpbforwpbakerypro_get_font_inline_style( $font_data );
        }

        $style = '<style>';
        if( $text_align != "" ){
            $style .=  ".$unique_class .product_meta{ text-align:{$text_align} !important; }";
        }

        if( $text_color != "" ){
            $style .=  ".$unique_class .product_meta{ color:{$text_color} !important; }";
        }

        if( $font_size != "" ){
            $style .=  ".$unique_class .product_meta{ font-size:{$font_size} !important; }";
        }

        if( $line_height != "" ){
            $style .=  ".$unique_class .product_meta{ line-height:{$line_height} !important; }";
        }
        if( $font_inline_style != "" ){
            $style .=  ".$unique_class .product_meta{ {$font_inline_style} }";
        }
        $style .= '</style>';

        ob_start();
        if ( empty( $product ) ) { return; }

        echo '<div class="'. esc_attr($unique_class. ' ' .$el_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';
        	woocommerce_template_single_meta();
        echo '</div>';

        return $style .= ob_get_clean();
    }

    public function integrateWithVC() {
    
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => __("WCB: Product Meta", 'wpbforwpbakery'),
            "base" => "wpbforwpbakery_product_meta",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_product_short_description_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => __('WC Builder', 'wpbforwpbakery'),
            "params" => array(
                array(
                  "param_name" => "text_align",
                  "heading" => __("Text Align", 'wpbforwpbakery'),
                  "type" => "dropdown",
                  "default_set" => 'left',
                  'value' => wpbforwpbakerypro_text_align_lists(),
                ),
                array(
                    'param_name' => 'text_color',
                    'heading' => __( 'Text color', 'wpbforwpbakery' ),
                    'type' => 'colorpicker',
                ),
                array(
                    'param_name' => 'font_size',
                    'heading' => __( 'Font Size', 'wpbforwpbakery' ),
                    'type' => 'textfield',
                    'description' => __( 'Ex: 23px', 'wpbforwpbakery' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
                ),
                array(
                    'param_name' => 'line_height',
                    'heading' => __( 'Line Height', 'wpbforwpbakery' ),
                    'type' => 'textfield',
                    'description' => __( 'Ex: 25px', 'wpbforwpbakery' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
                ),
                array(
                  'type' => 'checkbox',
                  'heading' => __( 'Use google font?', 'wpbforwpbakery' ),
                  'param_name' => 'use_google_font',
                  'description' => __( 'Use font family from google font.', 'wpbforwpbakery' ),
                ),
                array(
                  'type' => 'google_fonts',
                  'param_name' => 'google_font',
                  'settings' => array(
                    'fields' => array(
                      'font_family_description' => __( 'Select font family.', 'wpbforwpbakery' ),
                      'font_style_description' => __( 'Select font styling.', 'wpbforwpbakery' ),
                    ),
                  ),
                  'dependency' =>[
                      'element' => 'use_google_font',
                      'value' => array( 'true' ),
                  ],
                ),
                array(
                    'param_name' => 'el_class',
                    'heading' => __( 'Extra class name', 'wpbforwpbakery' ),
                    'type' => 'textfield',
                    'description' => __( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakery' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => __( "Wrapper Styling", "wpbforwpbakery" ),
                  "type" => "css_editor",
                  'group'  => __( 'Wrapper Styling', 'wpbforwpbakery' ),
              ),
            )
        ) );
    }
}

new WPBForWPbakery_Product_Meta();

}