<?php
class WPBForWPbakeryPro_Social_Share{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_social_share', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'product_social_title' => '', 
            'title_color' => '', 
            'icon_color' => '', 
            'icon_hover_color' => '', 
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');

        global $product;
        $product = wc_get_product();

        $style = '<style>';

        if( $title_color != "" ){
            $style .=  ".$unique_class h2{ color:{$title_color}; }";
        }

        if( $icon_color != "" ){
            $style .=  ".$unique_class ul li a{ color:{$icon_color} }";
        }

        if( $icon_hover_color != "" ){
            $style .=  ".$unique_class ul li a:hover{ color:{$icon_hover_color} }";
        }

        $style .= '</style>';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';
        
        if ( empty( $product ) ) {return; }

        $product_title  = get_the_title();
        $product_url    = get_permalink();
        $product_img    = wp_get_attachment_url( get_post_thumbnail_id() );

        $facebook_url   = '//www.facebook.com/sharer/sharer.php?u=' . esc_url($product_url);
        $twitter_url    = '//twitter.com/intent/tweet?status=' . rawurlencode( esc_html($product_title) ) . '+' . esc_url($product_url);
        $pinterest_url  = '//pinterest.com/pin/create/bookmarklet/?media=' . esc_url($product_img) . '&url=' . esc_url($product_url) . '&is_video=false&description=' . rawurlencode( esc_html($product_title) );
        $gplus_url      = '//plus.google.com/share?url='. esc_url($product_url);
        $reddit_url     = '//reddit.com/submit?url={'.  esc_url($product_url) .'}&title={'. esc_html($product_title) .'}';

        ?>
            <div class="wpbforwpbakerypro_product_social_share <?php echo esc_attr( $unique_class ); ?>">
                <?php
                    if( !empty( $product_social_title ) ){
                        echo '<h2>'.esc_html( $product_social_title ).'</h2>';
                    }
                ?>
                <ul>
                    <li><a href="<?php echo esc_url($facebook_url); ?>" target="_blank"><i class="fa fa-facebook"></i></a></li>
                    <li><a href="<?php echo esc_url($gplus_url); ?>" target="_blank"><i class="fa fa-google-plus"></i></a></li>
                    <li><a href="<?php echo esc_url($pinterest_url); ?>" target="_blank"><i class="fa fa-pinterest-p"></i></a></li>
                    <li><a href="<?php echo esc_url($twitter_url); ?>" target="_blank"><i class="fa fa-twitter"></i></a></li>
                    <li><a href="<?php echo esc_url($reddit_url); ?>" target="_blank"><i class="fa fa-reddit"></i></a></li>
                </ul>
            </div>

        <?php
    	echo '</div>';
        return $style.= ob_get_clean();
    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: Social Share", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_social_share",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_social_share_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
                array(
                    'param_name' => 'product_social_title',
                    'heading' => __( 'Title', 'wpbforwpbakery' ),
                    'type' => 'textfield',
                ),

                array(
                    'param_name' => 'title_color',
                    'heading' => __( 'Title Color', 'wpbforwpbakery' ),
                    'type' => 'colorpicker',
                ),
                array(
                    'param_name' => 'icon_color',
                    'heading' => __( 'Icon Color', 'wpbforwpbakery' ),
                    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
                ),

                array(
                    'param_name' => 'icon_hover_color',
                    'heading' => __( 'Icon Hover Color', 'wpbforwpbakery' ),
                    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
                ),

                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}

new WPBForWPbakeryPro_Social_Share();