<?php
class WPBForWPbakeryPro_Thankyou_Customer_Address_Details{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_thankyou_customer_address_details', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'el_class' => esc_html__('Thank you. Your order has been received.', 'wpbforwpbakerypro'), 
            'wrapper_css' => '', 
        ),$atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');
        $output = '';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';
        
        global $wp;
                
        if( isset($wp->query_vars['order-received']) ){
            $received_order_id = $wp->query_vars['order-received']; 
        }else{
            $received_order_id = wpbforwpbakerypro_get_last_order_id();
        }

        if( !$received_order_id ){ return; }
        
        $order = wc_get_order( $received_order_id );
        $show_customer_details = is_user_logged_in() && $order->get_user_id() === get_current_user_id();
        if ( $show_customer_details ) {
            wc_get_template( 'order/order-details-customer.php', array( 'order' => $order ) );
        }

    	echo '</div>';
        return $output.= ob_get_clean();
    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: Thank You Customer Address Details", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_thankyou_customer_address_details",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_thankyou_customer_address_details_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}

new WPBForWPbakeryPro_Thankyou_Customer_Address_Details();