<?php
/**
 * Constructor Parameters
 *
 * @param string    $text_domain your plugin text domain.
 * @param string    $parent_menu_slug the menu slug name where the "Recommendations" submenu will appear.
 * @param string    $submenu_label To change the submenu name.
 * @param string    $submenu_page_name an unique page name for the submenu.
 * @param int       $priority Submenu priority adjust.
 * @param string    $hook_suffix use it to load this library assets only to the recommedded plugins page. Not into the whol admin area.
 *
 */

if(class_exists('WpbForWpbakeryPro\Admin\HTRP_Recommended_Plugins')){
    $recommendations = new WpbForWpbakeryPro\Admin\HTRP_Recommended_Plugins(
        array( 
            'text_domain'       => 'wpbforwpbakerypro', 
            'parent_menu_slug'  => 'edit.php?post_type=wpbfwpb_template', 
            'menu_capability'   => 'manage_options', 
            'menu_page_slug'    => 'recommendations',
            'priority'          => '',
            'assets_url'        => '',
            'hook_suffix'       => 'wpbfwpb_template_page_recommendations'
        )
    );

    $recommendations->add_new_tab(array(
        'title' => esc_html__( 'Recommended', 'wpbforwpbakerypro' ),
        'active' => true,
        'plugins' => array(
            array(
                'slug'      => 'woolentor-addons-pro',
                'location'  => 'woolentor_addons_pro.php',
                'name'      => esc_html__( 'WooLentor Pro', 'wpbforwpbakerypro' ),
                'link'      => 'https://hasthemes.com/plugins/woolentor-pro-woocommerce-page-builder/',
                'author_link'=> 'https://hasthemes.com/',
                'description'=> esc_html__( 'WooLentor is one of the most popular WooCommerce Elementor Addons on WordPress.org. It has been downloaded more than 672,148 times and 60,000 stores are using WooLentor plugin. Why not you?', 'wpbforwpbakerypro' ),
            ),

            array(
                'slug'      => 'just-tables-pro',
                'location'  => 'just-tables-pro.php',
                'name'      => esc_html__( 'JustTables Pro', 'wpbforwpbakerypro' ),
                'link'      => 'https://hasthemes.com/wp/justtables/',
                'author_link'=> 'https://hasthemes.com/',
                'description'=> esc_html__( 'JustTables is an incredible WordPress plugin that lets you showcase all your WooCommerce products in a sortable and filterable table view. It allows your customers to easily navigate through different attributes of the products and compare them on a single page. This plugin will be of great help if you are looking for an easy solution that increases the chances of landing a sale on your online store.', 'wpbforwpbakerypro' ),
            ),

            array(
                'slug'      => 'whols-pro',
                'location'  => 'whols-pro.php',
                'name'      => esc_html__( 'Whols Pro', 'wpbforwpbakerypro' ),
                'link'      => 'https://hasthemes.com/plugins/whols-woocommerce-wholesale-prices/',
                'author_link'=> 'https://hasthemes.com/',
                'description'=> esc_html__( 'Whols is an outstanding WordPress plugin for WooCommerce that allows store owners to set wholesale prices for the products of their online stores. This plugin enables you to show special wholesale prices to the wholesaler. Users can easily request to become a wholesale customer by filling out a simple online registration form. Once the registration is complete, the owner of the store will be able to review the request and approve the request either manually or automatically.', 'wpbforwpbakerypro' ),
            ),

            array(
                'slug'      => 'multicurrencypro',
                'location'  => 'multicurrencypro.php',
                'name'      => esc_html__( 'Multi Currency Pro for WooCommerce', 'wpbforwpbakerypro' ),
                'link'      => 'https://hasthemes.com/plugins/multi-currency-pro-for-woocommerce/',
                'author_link'=> 'https://hasthemes.com/',
                'description'=> esc_html__( 'Multi-Currency Pro for WooCommerce is a prominent currency switcher plugin for WooCommerce. This plugin allows your website or online store visitors to switch to their preferred currency or their countryâ€™s currency.', 'wpbforwpbakerypro' ),
            ),

            array(
                'slug'      => 'email-candy-pro',
                'location'  => 'email-candy-pro.php',
                'name'      => esc_html__( 'Email Candy Pro', 'wpbforwpbakerypro' ),
                'link'      => 'https://hasthemes.com/plugins/email-candy-pro/',
                'author_link'=> 'https://hasthemes.com/',
                'description'=> esc_html__( 'Email Candy is an outstanding WordPress plugin that allows you to customize the default WooCommerce email templates and give a professional look to your WooCommerce emails. If you are tired of using the boring design of WooCommerce emails and want to create customized emails, then this plugin will come in handy.', 'wpbforwpbakerypro' ),
            ),

        )
    ));

    $recommendations->add_new_tab(array(
        'title' => esc_html__( 'You May Also Like', 'wpbforwpbakerypro' ),
        'plugins' => array(
            array(
                'slug'      => 'woolentor-addons',
                'location'  => 'woolentor_addons_elementor.php',
                'name'      => esc_html__( 'WooLentor', 'wpbforwpbakerypro' )
            ),
            array(
                'slug'      => 'wc-builder',
                'location'  => 'wc-builder.php',
                'name'      => esc_html__( 'WC Builder', 'wpbforwpbakerypro' )
            ),
            array(
                'slug'      => 'wishsuite',
                'location'  => 'wishsuite.php',
                'name'      => esc_html__( 'WishSuite', 'wpbforwpbakerypro' )
            ),
            array(
                'slug'      => 'quickswish',
                'location'  => 'quickswish.php',
                'name'      => esc_html__( 'QuickSwish', 'wpbforwpbakerypro' )
            ),
            array(
                'slug'      => 'whols',
                'location'  => 'whols.php',
                'name'      => esc_html__( 'Whols', 'wpbforwpbakerypro' )
            ),
            array(
                'slug'      => 'just-tables',
                'location'  => 'just-tables.php',
                'name'      => esc_html__( 'JustTables', 'wpbforwpbakerypro' )
            ),
            array(
                'slug'      => 'wc-multi-currency',
                'location'  => 'wcmilticurrency.php',
                'name'      => esc_html__( 'Multi Currency', 'wpbforwpbakerypro' )
            )
        )
    ));

    $recommendations->add_new_tab(array(
        'title' => esc_html__( 'Others', 'wpbforwpbakerypro' ),
        'plugins' => array(
            array(
               'slug'      => 'ht-mega-for-elementor',
               'location'  => 'htmega_addons_elementor.php',
               'name'      => esc_html__( 'HT Mega', 'wpbforwpbakerypro' )
           ),

           array(
               'slug'      => 'ht-slider-for-elementor',
               'location'  => 'ht-slider-for-elementor.php',
               'name'      => esc_html__( 'HT Slider For Elementor', 'wpbforwpbakerypro' )
           ),

           array(
               'slug'      => 'wp-plugin-manager',
               'location'  => 'plugin-main.php',
               'name'      => esc_html__( 'WP Plugin Manager', 'wpbforwpbakerypro' )
           ),

           array(
               'slug'      => 'ht-contactform',
               'location'  => 'contact-form-widget-elementor.php',
               'name'      => esc_html__( 'HT Contact Form 7', 'wpbforwpbakerypro' )
           ),

           array(
               'slug'      => 'ht-wpform',
               'location'  => 'wpform-widget-elementor.php',
               'name'      => esc_html__( 'HT WPForms', 'wpbforwpbakerypro' )
           ),

           array(
               'slug'      => 'hashbar-wp-notification-bar',
               'location'  => 'init.php',
               'name'      => esc_html__( 'HashBar', 'wpbforwpbakerypro' )
           ),

           array(
               'slug'      => 'ht-menu-lite',
               'location'  => 'ht-mega-menu.php',
               'name'      => esc_html__( 'HT Menu', 'wpbforwpbakerypro' )
           ),

           array(
               'slug'      => 'htmega-pro',
               'location'  => 'htmega_pro.php',
               'name'      => esc_html__( 'HT Mega Pro', 'wpbforwpbakerypro' ),
               'link'      => 'https://hasthemes.com/plugins/ht-mega-pro/',
               'author_link'=> 'https://hasthemes.com/',
               'description'=> esc_html__( 'HTMega is an absolute addon for elementor that includes 80+ elements & 360 Blocks with unlimited variations. HT Mega brings limitless possibilities. Embellish your site with the elements of HT Mega.', 'wpbforwpbakerypro' ),
           ),

           array(
               'slug'      => 'hashbar-pro',
               'location'  => 'init.php',
               'name'      => esc_html__( 'HashBar Pro', 'wpbforwpbakerypro' ),
               'link'      => 'https://hasthemes.com/plugins/wordpress-notification-bar-plugin/',
               'author_link'=> 'https://hasthemes.com/',
               'description'=> esc_html__( 'HashBar is a WordPress Notification / Alert / Offer Bar plugin which allows you to create unlimited notification bars to notify your customers. This plugin has option to show email subscription form (sometimes it increases up to 500% email subscriber), Offer text and buttons about your promotions. This plugin has the options to add unlimited background colors and images to make your notification bar more professional.', 'wpbforwpbakerypro' ),
           ),
        )
    ));
}