<?php

// add extra metabox tab to woocommerce
if( !function_exists('wpbforwpbakerypro_add_wc_extra_metabox_tab')){
    function wpbforwpbakerypro_add_wc_extra_metabox_tab($tabs){
        $new_tab = array(
            'label'    => esc_html__( 'Product Layout', 'wpbforwpbakerypro' ),
            'target'   => 'wpbforwpbakerypro_product_data',
            'class'    => '',
            'priority' => 85
        );
        $tabs[] = $new_tab;
        return $tabs;
    }
    add_filter( 'woocommerce_product_data_tabs', 'wpbforwpbakerypro_add_wc_extra_metabox_tab', 10, 1 );
}

// add metabox to tab
if( !function_exists('wpbforwpbakerypro_add_metabox_to_general_tab')){
    function wpbforwpbakerypro_add_metabox_to_general_tab(){
         global $post;
        echo '<div id="wpbforwpbakerypro_product_data" class="panel woocommerce_options_panel hidden">';

            $value = get_post_meta( $post->ID, '_selectproduct_layout', true );

            if( empty( $value ) ) $value = '0';
            $option_arg = [
                'id'      => '_selectproduct_layout',
                'label'   => esc_html__( 'Select Product Layout', 'wpbforwpbakerypro' ),
                'options' =>  array( esc_html__( 'Select Product Layout', 'wpbforwpbakerypro' ) ),
                'value'   => $value
            ];
            if( function_exists('wpbforwpbakerypro_post_list_arr') ){
                $option_arg['options'] = wpbforwpbakerypro_post_list_arr('wpbfwpb_template');
            }
            woocommerce_wp_select( $option_arg );
        echo '</div>';
    }
    add_action( 'woocommerce_product_data_panels', 'wpbforwpbakerypro_add_metabox_to_general_tab' );
}

// Update data
if( !function_exists('wpbforwpbakerypro_save_metabox_of_general_tab') ){
    function wpbforwpbakerypro_save_metabox_of_general_tab( $post_id ){
        $selectproduct_layout = wp_kses_post( stripslashes( $_POST['_selectproduct_layout'] ) );
        update_post_meta( $post_id, '_selectproduct_layout', $selectproduct_layout);
    }
    add_action( 'woocommerce_process_product_meta', 'wpbforwpbakerypro_save_metabox_of_general_tab');
}

/*
* Product Category Meta Field
*/

add_action('product_cat_add_form_fields', 'wpbforwpbakerypro_taxonomy_add_new_meta_field', 15, 1 );
add_action('product_cat_edit_form_fields', 'wpbforwpbakerypro_taxonomy_edit_meta_field', 15, 1 );
add_action('edited_product_cat', 'wpbforwpbakerypro_save_taxonomy_custom_meta', 15, 1 );
add_action('create_product_cat', 'wpbforwpbakerypro_save_taxonomy_custom_meta', 15, 1 );

//Product Category Create page
function wpbforwpbakerypro_taxonomy_add_new_meta_field() {
    ?>
    <div class="form-field term-group">
        <label for="wpbforwpbakery_selectcategory_layout"><?php esc_html_e('Category Layout', 'wpbforwpbakerypro'); ?></label>
        <select class="postform" id="equipment-group" name="wpbforwpbakery_selectcategory_layout">
            <?php
            	if( function_exists('wpbforwpbakerypro_post_list_arr') ):
            	 foreach ( wpbforwpbakerypro_post_list_arr('wpbfwpb_template') as $catlayout_key => $catlayout ) : ?>
               		<option value="<?php echo esc_attr( $catlayout_key ); ?>"><?php echo esc_html__( $catlayout, 'wpbforwpbakerypro' ); ?></option>
            <?php
        		endforeach;
        		endif;
        	?>
        </select>
    </div>
    <?php
}

//Product Cat Edit page
function wpbforwpbakerypro_taxonomy_edit_meta_field( $term ) {

    //getting term ID
    $term_id = $term->term_id;

    // retrieve the existing value(s) for this meta field.
    $category_layout = get_term_meta( $term_id, 'wpbforwpbakery_selectcategory_layout', true);

    ?>
        <tr class="form-field">
            <th scope="row" valign="top"><label for="wpbforwpbakery_selectcategory_layout"><?php esc_html_e( 'Category Layout', 'wpbforwpbakerypro' ); ?></label></th>
            <td><select class="postform" id="wpbforwpbakery_selectcategory_layout" name="wpbforwpbakery_selectcategory_layout">
                <?php if( function_exists('wpbforwpbakerypro_post_list_arr') ) foreach ( wpbforwpbakerypro_post_list_arr('wpbfwpb_template') as $catlayout_key => $catlayout ) : ?>
                    <option value="<?php echo esc_attr( $catlayout_key ); ?>" <?php selected( $category_layout, $catlayout_key ); ?>><?php echo esc_html( $catlayout ); ?></option>
                <?php endforeach; ?>
            </select></td>
        </tr>
    <?php
}

// Save extra taxonomy fields callback function.
function wpbforwpbakerypro_save_taxonomy_custom_meta( $term_id ) {
    $categorylayout = filter_input( INPUT_POST, 'wpbforwpbakery_selectcategory_layout' );
    update_term_meta( $term_id, 'wpbforwpbakery_selectcategory_layout', $categorylayout);
}



// template layout metabox
function wpbforwpbakerypro_tmpl_layout_get_meta( $value ) {
	global $post;

	$field = get_post_meta( $post->ID, $value, true );
	if ( ! empty( $field ) ) {
		return is_array( $field ) ? stripslashes_deep( $field ) : stripslashes( wp_kses_decode_entities( $field ) );
	} else {
		return false;
	}
}

function wpbforwpbakerypro_tmpl_layout_add_meta_box() {
	add_meta_box(
		'wpbforwpbakery_tmpl_layout',
		__( 'Template Layout', 'wpbforwpbakery' ),
		'wpbforwpbakerypro_tmpl_layout_html',
		'wpbfwpb_template',
		'side',
		'default'
	);
}
add_action( 'add_meta_boxes', 'wpbforwpbakerypro_tmpl_layout_add_meta_box' );

function wpbforwpbakerypro_tmpl_layout_html( $post) {
	wp_nonce_field( '_wpbforwpbakery_tmpl_layout_nonce', 'wpbforwpbakery_tmpl_layout_nonce' ); ?>

	<p>
		<select name="wpbforwpbakery_tmpl_layout" id="wpbforwpbakery_tmpl_layout">
			<option <?php echo (wpbforwpbakerypro_tmpl_layout_get_meta( 'wpbforwpbakery_tmpl_layout' ) === 'Default' ) ? 'selected' : '' ?>>Default</option>
			<option <?php echo (wpbforwpbakerypro_tmpl_layout_get_meta( 'wpbforwpbakery_tmpl_layout' ) === 'Full Width' ) ? 'selected' : '' ?>>Full Width</option>
		</select>
	</p><?php
}

function wpbforwpbakerypro_tmpl_layout_save( $post_id ) {
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;
	if ( ! isset( $_POST['wpbforwpbakery_tmpl_layout_nonce'] ) || ! wp_verify_nonce( $_POST['wpbforwpbakery_tmpl_layout_nonce'], '_wpbforwpbakery_tmpl_layout_nonce' ) ) return;
	if ( ! current_user_can( 'edit_post', $post_id ) ) return;

	if ( isset( $_POST['wpbforwpbakery_tmpl_layout'] ) )
		update_post_meta( $post_id, 'wpbforwpbakery_tmpl_layout', esc_attr( $_POST['wpbforwpbakery_tmpl_layout'] ) );
}
add_action( 'save_post', 'wpbforwpbakerypro_tmpl_layout_save' );