<?php
/*
* Shop Page
*/

// Add to Cart Button Text
add_filter( 'woocommerce_product_add_to_cart_text', 'wpbforwpbakerypro_custom_add_cart_button_shop_page', 99, 2 );
function wpbforwpbakerypro_custom_add_cart_button_shop_page( $label ) {
   return wpbforwpbakerypro_get_option( 'shop_add_to_cart_txt', 'wpbforwpbakery_rename_label_tabs', __('Add To Cart', 'wpbforwpbakerypro' ), true );
}

/*
* Product Details Page
*/

// Add to Cart Button Text
add_filter( 'woocommerce_product_single_add_to_cart_text', 'wpbforwpbakerypro_custom_add_cart_button_single_product' );
function wpbforwpbakerypro_custom_add_cart_button_single_product( $label ) {
   return wpbforwpbakerypro_get_option( 'add_to_cart_txt', 'wpbforwpbakery_rename_label_tabs', __('Add To Cart', 'wpbforwpbakerypro' ), true);
}

//Description tab
add_filter( 'woocommerce_product_description_tab_title', 'wpbforwpbakerypro_rename_description_product_tab_label' );
function wpbforwpbakerypro_rename_description_product_tab_label( $content ) {
    return __( wpbforwpbakerypro_get_option( 'description_tab_menu_titlep', 'wpbforwpbakery_rename_label_tabs', 'Description', true ), 'wpbforwpbakerypro' );
}

add_filter( 'woocommerce_product_description_heading', 'wpbforwpbakerypro_rename_description_tab_heading' );
function wpbforwpbakerypro_rename_description_tab_heading( $content ) {
    return wpbforwpbakerypro_get_option( 'description_tab_menu_titlep', 'wpbforwpbakery_rename_label_tabs', $content, true );
}

//Additional Info tab
add_filter( 'woocommerce_product_additional_information_tab_title', 'wpbforwpbakerypro_rename_additional_information_product_tab_label' );
function wpbforwpbakerypro_rename_additional_information_product_tab_label( $content ) {
    return wpbforwpbakerypro_get_option( 'additional_information_tab_menu_titlep', 'wpbforwpbakery_rename_label_tabs',$content, true );
}

add_filter( 'woocommerce_product_additional_information_heading', 'wpbforwpbakerypro_rename_additional_information_tab_heading' );
function wpbforwpbakerypro_rename_additional_information_tab_heading( $content ) {
    return wpbforwpbakerypro_get_option( 'additional_information_tab_menu_titlep', 'wpbforwpbakery_rename_label_tabs', $content, true );
}

//Reviews Info tab
add_filter( 'woocommerce_product_reviews_tab_title', 'wpbforwpbakerypro_rename_reviews_product_tab_label' );
function wpbforwpbakerypro_rename_reviews_product_tab_label( $content ) {
    return wpbforwpbakerypro_get_option( 'reviews_tab_menu_titlep', 'wpbforwpbakery_rename_label_tabs', $content, true );
}


/*
* Checkout Page
*/
add_filter( 'woocommerce_checkout_fields' , 'wpbforwpbakerypro_rename_wc_checkout_fields', 100 );
function wpbforwpbakerypro_rename_wc_checkout_fields( $fields ) {
    $first_name = wpbforwpbakerypro_get_option( 'checkout_firstname_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $last_name  = wpbforwpbakerypro_get_option( 'checkout_lastname_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $company    = wpbforwpbakerypro_get_option( 'checkout_company_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $country    = wpbforwpbakerypro_get_option( 'checkout_country_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $address_1  = wpbforwpbakerypro_get_option( 'checkout_address_1_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $address_2  = wpbforwpbakerypro_get_option( 'checkout_address_2_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $city       = wpbforwpbakerypro_get_option( 'checkout_city_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $state      = wpbforwpbakerypro_get_option( 'checkout_state_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $postcode   = wpbforwpbakerypro_get_option( 'checkout_postcode_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $email      = wpbforwpbakerypro_get_option( 'checkout_email_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $phone      = wpbforwpbakerypro_get_option( 'checkout_phone_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );

    if( $first_name ){
        $fields['billing']['billing_first_name']['label'] = $first_name;
        $fields['shipping']['shipping_first_name']['label'] = $first_name;
    }


    if( $last_name ){
        $fields['billing']['billing_last_name']['label'] = $last_name;
        $fields['shipping']['shipping_last_name']['label'] = $last_name;
    }

    if( $company ){
        $fields['billing']['billing_company']['label'] = $company;
        $fields['shipping']['shipping_company']['label'] = $company;
    }

    if( $country ){
        $fields['billing']['billing_country']['label'] = $country;
        $fields['shipping']['shipping_country']['label'] = $country;
    }

    if( $address_1 ){
        $fields['billing']['billing_address_1']['label'] = $address_1;
        $fields['shipping']['shipping_address_1']['label'] = $address_1;
    }

    if( $city ){
        $fields['billing']['billing_city']['label'] = $city;
        $fields['shipping']['shipping_city']['label'] = $city;
    }

    if( $state ){
        $fields['billing']['billing_state']['label'] = $state;
        $fields['shipping']['shipping_state']['label'] = $state;
    }

    if( $postcode ){
        $fields['billing']['billing_postcode']['label'] = $postcode;
        $fields['shipping']['shipping_postcode']['label'] = $postcode;
    }

    if( $email ){
        $fields['billing']['billing_email']['label'] = $email;
        $fields['shipping']['shipping_email']['label'] = $email;
    }

    if( $phone ){
        $fields['billing']['billing_phone']['label'] = $phone;
        $fields['shipping']['shipping_phone']['label'] = $phone;
    }

    return $fields;
}

// localize js labels
add_filter('wc_address_i18n_params', 'wpbforwpbakerypro_rename_wc_checkout_fields_js');
function wpbforwpbakerypro_rename_wc_checkout_fields_js( $data ){
    // decode json
    $locale = json_decode( $data['locale'], true );

    $address_1  = wpbforwpbakerypro_get_option( 'checkout_address_1_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $city       = wpbforwpbakerypro_get_option( 'checkout_city_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $state      = wpbforwpbakerypro_get_option( 'checkout_state_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );
    $postcode   = wpbforwpbakerypro_get_option( 'checkout_postcode_labelp', 'wpbforwpbakery_rename_label_tabs', '', true );


    if( $address_1 ){
        $locale['default']['address_1']['label'] = $address_1;
    }

    if( $city ){
        $locale['default']['city']['label'] = $city;
    }

    if( $state ){
        $locale['default']['state']['label'] = $state;
    }

    if( $postcode ){
        $locale['default']['postcode']['label'] = $postcode;
    }

    // encode json
    $locale         = json_encode($locale);
    $data['locale'] = $locale;

    return $data;
}


add_filter( 'woocommerce_order_button_text', 'wpbforwpbakerypro_rename_place_order_button' );
function wpbforwpbakerypro_rename_place_order_button( $content ) {
   return wpbforwpbakerypro_get_option( 'checkout_placeorder_btn_txtp', 'wpbforwpbakery_rename_label_tabs', $content, true );
}