<?php
// Exit if accessed directly
if( ! defined( 'ABSPATH' ) ) exit();

if ( !class_exists( 'WPBForWPbakeryPro_Addons_Init' ) ) {

    class WPBForWPbakeryPro_Addons_Init{

        private static $_instance = null;
        public static function instance() {
            if ( is_null( self::$_instance ) ) {
                self::$_instance = new self();
            }
            return self::$_instance;
        }

        public function __construct(){
        	if ( class_exists( 'WooCommerce' ) ) {
        	    $this->includes_widgets();
                $this->inlcude_files();
        	}
        }

        // Include Widgets Files
        public function includes_widgets(){

            $wpbforwpbakerypro_addons  = array(
            	'archive_product',
            	'archive_header_title',
            	'archive_header_description',
            	'product_title',
            	'product_description',
            	'product_short_description',
            	'product_image',
            	'product_price',
            	'product_add_to_cart',
            	'product_meta',
            	'product_stock',
            	'product_rating',
            	'product_data_tab',
            	'product_related',
            	'product_reviews',
            	'product_upsell',
            	'product_additional_information',
                'social_share',
                'cart_table',
                'cart_total',
                'checkout_billing',
                'order_review',
                'checkout_payment',
                'checkout_shipping_form',
                'checkout_additional_form',
                'thankyou_order',
                'thankyou_order_details',
                'thankyou_customer_address_details',
                'myaccount_dashboard',
                'myaccount_address',
                'myaccount_download',
                'myaccount_edit_account',
                'myaccount_login_form',
                'myaccount_logout',
                'myaccount_order',
                'myaccount_register_form'
            );

            foreach ( $wpbforwpbakerypro_addons as $addon ){
                if (  ( wpbforwpbakerypro_get_option( 'wpb_'. $addon, 'wpbforwpbakery_elements_tabs', 'on' ) === 'on' ) && file_exists( WPBFORWPBAKERY_PRO_ADDONS_PL_PATH.'/includes/addons/'.$addon.'.php' ) ){
                    require_once ( WPBFORWPBAKERY_PRO_ADDONS_PL_PATH.'/includes/addons/'.$addon.'.php' );
                }
            }
        }

        public function inlcude_files(){
            if( wpbforwpbakerypro_get_option( 'enablecustomlayout', 'wpbforwpbakery_woo_template_tabs', 'on' ) == 'on' ){
                // include_once ( WPBFORWPBAKERY_PRO_ADDONS_PL_PATH.'includes/woo_shop.php' );
                include_once ( WPBFORWPBAKERY_PRO_ADDONS_PL_PATH.'includes/archive-product-render.php' );

                // rename label
                if( !is_admin() && !is_plugin_active('wc-builder/wc-builder.php') && wpbforwpbakerypro_get_option( 'enablerenamelabel', 'wpbforwpbakery_rename_label_tabs', 'off' ) == 'on' ){
                    require( WPBFORWPBAKERY_PRO_ADDONS_PL_PATH.'includes/rename_label.php' );
                }
            }


        }
    }

    WPBForWPbakeryPro_Addons_Init::instance();
}